<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="input | select | textarea">
        <xsl:copy>
            <xsl:apply-templates select="@*" />
            <xsl:attribute name="disabled">disabled</xsl:attribute>
            <xsl:apply-templates />
        </xsl:copy>
    </xsl:template>
    <xsl:template match="a">
        <xsl:copy>
            <xsl:choose>
                <!-- If it is a tab, then we will not try and disable it -->
                <xsl:when test="contains(@class, 'selectedTab') or contains(@class, 'unselectedTab')">
                    <xsl:apply-templates select="@*" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="@*[(local-name() != 'href') and not(starts-with(local-name(), 'on'))]" />
                    <xsl:attribute name="disabled">disabled</xsl:attribute>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:apply-templates />
        </xsl:copy>
    </xsl:template>
    <!-- Ensure that we never disable controls that have the neverReadOnly class applied to them -->
    <xsl:template match="*[contains(@class, 'neverReadOnly')]" priority="10">
        <xsl:copy>
            <xsl:apply-templates select="@*" />
            <xsl:apply-templates />
        </xsl:copy>
    </xsl:template>
    <xsl:template match="node() | @*">
        <xsl:copy>
            <xsl:apply-templates select="@*" />
            <xsl:apply-templates />
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>
